#include <windows.h>
#include <stdio.h>

static char cmdline[32768];

int WINAPI WinMain(HINSTANCE hi, HINSTANCE hpi, LPSTR cmd, int show)
{
	HWND win;
	DWORD thread;
	HMODULE dll;
	HOOKPROC func;
	HHOOK hook;
	const char *exe;
	const char *name;
	DWORD code;

	STARTUPINFO startup;
        PROCESS_INFORMATION pi;

	int ret = 1;

	exe = "Titan Quest.exe";
	if (GetFileAttributes(exe) != INVALID_FILE_ATTRIBUTES)
	{
		name = "Titan Quest";
	}
	else
	{
		exe = "Tqit.exe";
		if (GetFileAttributes(exe) != INVALID_FILE_ATTRIBUTES)
		{
			name = "Titan Quest: Immortal Throne";
		}
		else
		{
			return ret;
		}
	}

	dll = LoadLibrary("TQCam.dll");
	if (!dll)
	{
		return ret;
	}

	func = (void *)GetProcAddress(dll, "TQC_MouseHook");

	memset(&startup, 0, sizeof(STARTUPINFO));
        memset(&pi, 0, sizeof(PROCESS_INFORMATION));

	snprintf(cmdline, 32768, "\"%s\" %s\n", exe, cmd);

	if (func && CreateProcess(exe, cmdline, 0, 0, 0, 0, 0, 0, &startup, &pi))
	{
		while(GetExitCodeProcess(pi.hProcess, &code) && code == STILL_ACTIVE)
		{
			win = 0;

			while ((win = FindWindowEx(0, win, name, name)))
			{
				DWORD pid;
				thread = GetWindowThreadProcessId(win, &pid);
				if (thread && pid == pi.dwProcessId)
				{
					goto found;
				}
			}

			Sleep(1000);
		}

		if (0)
		{
	found:
			hook = SetWindowsHookEx(WH_MOUSE, func, dll, thread);
			if (hook)
			{
				WaitForSingleObject(pi.hProcess, INFINITE);
				UnhookWindowsHookEx(hook);
				ret = 0;
			}
		}

		CloseHandle(pi.hThread);
		CloseHandle(pi.hProcess);
	}

	FreeLibrary(dll);

	return ret;
}
